package samples;

import java.io.FileNotFoundException;
import java.io.IOException;
import javax.vecmath.Vector3f;

import org.jdesktop.lg3d.utils.shape.ImagePanel;
import org.jdesktop.lg3d.wg.Component3D;
import org.jdesktop.lg3d.wg.Cursor3D;
import org.jdesktop.lg3d.wg.Frame3D;
import org.jdesktop.lg3d.wg.Thumbnail;

public class HelloWorld3 {
    private static final String IMAGE_FILE = "helloworld.png";

    // 摜̑傫 200x25 pixel
    // [gϊp 0.0254 [inch/m] / 72.0f [pixel/inch]
    private static final float WIDTH = 200.0f * 0.0254f / 72.0f;
    private static final float HEIGHT = 25.0f * 0.0254f / 72.0f;
    private static final float DEPTH = 0.005f;
    
    public HelloWorld3() {
        Frame3D frame3d = new Frame3D();
        
        try {
            ImagePanel panel = new ImagePanel(IMAGE_FILE, WIDTH, HEIGHT);

            // ImagePanel ͒ Frame3D (Container3D)
            // ɂ͂邱ƂłȂA
            // Component3D ɂ͂͂邱Ƃł
            Component3D comp3d = new Component3D();
            comp3d.addChild(panel);
            
            // J[\̕ύX
            comp3d.setCursor(Cursor3D.DEFAULT_CURSOR);            

            // Frame3D ɂ͂̂ Component3D 
            frame3d.addChild(comp3d);

            // TCYύX sݒ肷
            frame3d.setPreferredSize(new Vector3f(WIDTH, HEIGHT, DEPTH));

            // TlC̐
            Thumbnail thumbnail = new Thumbnail();
 
            // TlCp̃VFCv k\̂ő傫߂ɂ
            ImagePanel thumbnailPanel = new ImagePanel(IMAGE_FILE, WIDTH*4f, HEIGHT*4f);
            Component3D thumbnailComp3d = new Component3D();
            thumbnailComp3d.addChild(thumbnailPanel);
 
            // TlC Component3D ǉ
            thumbnail.addChild(thumbnailComp3d);
 
            // TlCTCYݒ肷
            // k\̂ŃTCY͓ł܂Ȃ
            thumbnail.setPreferredSize(new Vector3f(WIDTH*4f, HEIGHT*4f, DEPTH));
 
            // Frame3D ɃTlCݒ
            frame3d.setThumbnail(thumbnail);

            // 
            frame3d.changeEnabled(true);
            frame3d.changeVisible(true);        

        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new HelloWorld3();
    }
}
